#!/bin/bash -e

SOURCE_ROOT=dropbear-2013.59
TAR_BALL=${SOURCE_ROOT}.tar.bz2
BUILD_ARCH=sip

if [ "$1" == "" ] ; then
	echo "Usage ./build.sh [arm1176] [mips] [clean] "
	exit
fi

if [ "$1" == clean ] ; then
	rm -rv usr
	rm -rv ${SOURCE_ROOT}
else
	if [ -e usr ] ; then
		echo "Run ./build.sh clean"
		exit
	fi
	
	BUILD_ARCH=$1
	if [ "$BUILD_ARCH" != "arm1176" -a "$BUILD_ARCH" != "mips" ] ; then
		echo "Build target $BUILD_ARCH not supported"
		exit
	fi
	mkdir -pv usr/bin
	mkdir -pv usr/sbin

	tar xvjf ${TAR_BALL}
	cp Makefile.opera ${SOURCE_ROOT}
	pushd .
	cd ${SOURCE_ROOT}
	#################################
	#    patch files are created in this top-level dir via
	#       diff -urN dropbear-2013.59/original_source.c  dropbear-2013.59/modified_source.c > pathces/patch_file
	#    and can be applied via
	#	patch -p1 < ../anyrequired.patch
	patch -p1 < ../patches/options.h.patch
	patch -p1 < ../patches/log_format.patch
	
	#################################
	make -f Makefile.opera OPERA_TARGET=${BUILD_ARCH} OPERA_WORKPOINT=WP_LO SWITCH_PLATFORM=SIP OPERA_DEBUGINFO=YES
	popd
	tar cvz -f tarballs/${BUILD_ARCH}-dropbear.tgz usr
fi
